#!/usr/bin/env python
# -*- coding: utf-8 -*-

try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
	import gobject
except:
	sys.exit(1)

import threading

class GladeWindow:
	"""Base class that implements connections to a window in a glade file.
		 This class has all the widgets on a window from a glade file as attributes
		 and it connects signals to methods with the same name

		A class derivated from this class should overwrite the __init__() like this
		def __init__(self):
			GladeWindow.__init__(self, "my glade file.glade", "my window")

		Once this is done signals will be connected to method with the same name
		 and all widgets will be referenced as an attribute with the same name as
		 the widget. Notice the widget tree will be available as the widgets attribute
	"""

	def __init__(self, gladefile, window):
		#Load the window
		self.widgets = gtk.glade.XML(gladefile, window)
		#Connect signals to methods on this instance
		self.widgets.signal_autoconnect(self);
		
		for widget in self.widgets.get_widget_prefix(''):
			name = widget.get_name()
			assert not hasattr(self, name)
			setattr(self, name, widget)

def thread(fn):
	"""Creates a threading wrapper around f
		this method is used by appling the decorator @thread
		to perform an action on a thread.
		See: http://www.oreillynet.com/onlamp/blog/2006/07/pygtk_and_threading.html
		And: http://amix.dk/blog/viewEntry/19346
	"""
	def run(*k, **kw):
		t = threading.Thread(target=fn, args=k, kwargs=kw)
		t.start()
	return run

