#!/usr/bin/env python
# -*- coding: utf-8 -*-

def recursive_parser(data):
	"""
	Parse a parenthesized list as defined by RFC 3501 section 4.4

	Example data string:
'2 (ENVELOPE ("Tue, 21 Oct 2008 11:23:09 +0200" "Re: Hej," (("Sabrine Mouritsen" NIL "sabrinemouse" "gmail.com")) (("Sabrine Mouritsen" NIL "sabrinemouse" "gmail.com")) (("Sabrine Mouritsen" NIL "sabrinemouse" "gmail.com")) (("Raptor Mail" NIL "testraptormail" "gmail.com")) NIL NIL "<48ac0d900810210222o63e50ffl392cb68912da63b4@mail.gmail.com>" "<dcf240140810210223q698377b9yd2959b230203a3ea@mail.gmail.com>"))'
	"""
	data += " "
	data_list = []
	i = 0
	in_string = False
	last_i = 0
	while i < len(data):
		if data[i] == '"':
			in_string = not in_string
		elif data[i] == '(' and data[i+1] == ')' and not in_string:
			data_list += [[]]
			last_i = i +3
			i +=2
		elif data[i] == '(' and not in_string:
			i += 1
			i_before = i
			started_lists = 0
			while i < len(data):
				if data[i] == '"':
					in_string = not in_string
				elif data[i] == '(' and not in_string:
					started_lists += 1
				elif data[i] == ')' and not in_string:
					started_lists -= 1
					if started_lists < 0:
						break
				i += 1
			else:
				raise ValueError, "Badly formatted data string"
			in_string = False
			data_list += [recursive_parser(data[i_before:i])]
			last_i = i+1
			i += 1
		elif data[i] == ' ' and not in_string:
			#TODO: fix if string like " " is parsed or if there's a string with
			new_part = data[last_i:i]
			if new_part == "" or new_part == " ":
				pass
			elif new_part[0] == '"' and new_part[-1] == '"':
				data_list += [new_part[1:-1]]
			elif new_part == "NIL":
				data_list += [""]
			else:
				data_list += [new_part]
			last_i = i+1
		i += 1
	return data_list

def print_list(data, d = 0):
	for i in data:
		if type(i) == type([]):
			print_list(i, d+1)
		else:
			print "\t"*d + str(i)
