#!/usr/bin/env python
# -*- coding: utf-8 -*-

try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
	import gobject
	import gtk.gdk
	import pango
except:
	sys.exit(1)

import mainWindow
import startAssistant
import gmail_cache

#We're using YAML for parsing the configfile
import yaml

#Configration directory
conf_dir = "."
db_dir = conf_dir

#Initilize threading support
gtk.gdk.threads_init()
gobject.threads_init()

#This is the config file:
configfile = conf_dir + "/RaptorMail.conf"

try:
	#Try to load configuration
	FS = open(configfile, "r")
	raw_conf = FS.read()
	FS.close()
	config = yaml.load(raw_conf)
	#Get configuration
	username = config["GMail login"]["username"]
	password = config["GMail login"]["password"]
	pubkey = [int(config["Raptor public key"]["e"], 16), int(config["Raptor public key"]["n"], 16)]
	privkey = [int(config["Raptor private key"]["d"], 16), int(config["Raptor private key"]["n"], 16)]
	db_path = config["Local database path"]
	#Start gmail instance
	gmail = gmail_cache.GMail(username, password, db_path)
except:
	#Starts once assistant is completed
	guide = startAssistant.StartAssistant(db_dir)
	gmail, pubkey, privkey, db_path = guide.run()

	#Check if the dialog was cannceled
	if gmail == None:
		exit()

	#Save configuration
	config = {	
				"GMail login": {
						"username": gmail.username,
						"password": gmail.password
					},
				"Raptor public key": {
						"e": hex(long(pubkey[0]))[:-1],
						"n": hex(long(pubkey[1]))[:-1]
					},
				"Raptor private key": {
						"d": hex(long(privkey[0]))[:-1],
						"n": hex(long(privkey[1]))[:-1]
					},
				"Local database path": db_path
				}
	#Try to delete config file if it exists
	try:
		import os
		os.remove(configfile)
	except:
		pass	#Don't care if there was not config file to delete
	#Create new config file and save data to it
	FS = open(configfile, "w")
	FS.write(yaml.dump(config, default_flow_style = False))	#With special setting that enables us to make blocks/sections in config file
	FS.close()

#Start the application
mainWindow.MainWindow(gmail, pubkey, privkey)
gtk.main()
