#!/usr/bin/env python
# -*- coding: utf-8 -*-

try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
	import gobject
	import gtk.gdk
except:
	sys.exit(1)

import gladeWindow
from gladeWindow import thread
import RSA
import gmail_cache
import datetime
import pickle
import email.message
import pango
import aboutbox
import pymanual

#Import dialogs
import deleteMessageDialog
import applyLabelDialog
import verifyPublickeyDialog

#TODO: Import Aboutbox and RaptorManual
#TODO: Replace Mailtextview with a gtkhtml2 widget and display html
#Example of gtkhtml: /usr/share/doc/python-gtkhtml2/examples/simple-browser.py
#import gtkhtml2

class MainWindow(gladeWindow.GladeWindow):
	def __init__(self, Gmail, PublicKey, PrivateKey):
		"""Initialize using GMail instance, public and private key"""
		#Save keys and gmail interface
		self.PublicKey = PublicKey
		self.PrivateKey = PrivateKey
		self.gmail = Gmail
		self.message_id = None		#Currently viewed message ID
		self.conversation = None	#Currently viewed conversation
		self.in_reply_to_id = None	#Email currently being replied to
		self.lastViewedLabel = "INBOX"	#Last label that was viewed

		#Initialize GUI
		gladeWindow.GladeWindow.__init__(self, "raptormail.glade", "MainWindow")

		#Start threading
		gtk.gdk.threads_init()
		gobject.threads_init()

		#Create mail_integrity table if needed
		self.gmail.database.execute("SELECT count(name) FROM sqlite_master WHERE type='table' AND name = 'mail_integrity'")
		if self.gmail.database.fetchone()[0] < 1:
			self.gmail.database.execute("CREATE TABLE mail_integrity(msg_id TEXT, signed INT, encrypted INT)")

		#Create contacts if needed
		self.gmail.database.execute("SELECT count(name) FROM sqlite_master WHERE type='table' AND name = 'contacts'")
		if self.gmail.database.fetchone()[0] < 1:
			self.gmail.database.execute("CREATE TABLE contacts(email TEXT, e TEXT, n TEXT)")
		self.PopulateContacts()

		#Setup store and list for labellistview
		col = gtk.TreeViewColumn("Index", gtk.CellRendererText(), text=0)
		self.labellistview.append_column(col)
		self.update_labels()

		#Create labels menu
		self.CreateLabelMenu()

		#Setup store and list for maillistview
		icon1 = gtk.TreeViewColumn('', gtk.CellRendererPixbuf(), pixbuf=5)
		icon2 = gtk.TreeViewColumn('', gtk.CellRendererPixbuf(), pixbuf=6)
		col1 = gtk.TreeViewColumn("From", gtk.CellRendererText(), text=0, weight = 4)
		col1 = gtk.TreeViewColumn("From", gtk.CellRendererText(), text=0, weight = 4)
		col2 = gtk.TreeViewColumn("Subject", gtk.CellRendererText(), text=1, weight = 4)
		col3 = gtk.TreeViewColumn("Date", gtk.CellRendererText(), text=2, weight = 4)
		self.maillistview.append_column(icon1)
		self.maillistview.append_column(icon2)
		self.maillistview.append_column(col1)
		self.maillistview.append_column(col2)
		self.maillistview.append_column(col3)

		self.ViewLabel("INBOX")

		#Setup progress report for gmail
		self.gmail.progress_report = self.update_sync_progress

		#Get context id's from statusbar
		self.sync_status_id = self.statusbar.get_context_id("synchronisation status")
		self.send_email_id = self.statusbar.get_context_id("send email")

		#Update conversation buttons:
		self.updateConversationButtons()

		#Hide encrypted and signed icons
		self.MailUnsignedIcon.show()
		self.MailEncryptedIcon.hide()
		self.MailSignedIcon.hide()

	def activateAboutbox(self, widget):
		about = aboutbox.mainAboutbox()
		
	def activateRaptorMail(self, widget):
		manual = pymanual.Manual()
		
	def update_labels(self):
		self.labelliststore = gtk.ListStore(str)
		self.labellistview.set_model(self.labelliststore)
		for label in self.gmail.get_labels():
			self.labelliststore.append([label])

	@thread
	def SyncWithGmail(self, widget, args = None):
		#Show init message
		gtk.gdk.threads_enter()
		self.Synctoolbutton.set_sensitive(False)
		self.statusbar.push(self.sync_status_id, "Synchronisation initiated...")
		gtk.gdk.threads_leave()

		#Sync
		new_mails = self.gmail.sync()

		#Show complete message
		gtk.gdk.threads_enter()

		#Update labels
		self.update_labels()

		#Update statusbar		
		self.statusbar.pop(self.sync_status_id)
		self.statusbar.push(self.sync_status_id, "Synchronisation complete.")
		
		#Update view if viewing list of mails
		if self.ContentViews.get_current_page() == 0:
			self.ViewLabel()

		#Update labels:
		self.CreateLabelMenu()

		#Extract contacts from new mails and add them to contact completion
		conn, cur = self.gmail.get_database()		#Get a database connection for this thread
		for msg_id in new_mails:
			self.ProcessNewMail(msg_id, cur)
			new_mails.remove(msg_id)
		self.gmail.return_database(conn, cur)		#Return the database
		self.Synctoolbutton.set_sensitive(True)
		gtk.gdk.threads_leave()

	#thread
	def update_sync_progress(self, procentage):
		"""Update sync progress from GMail"""
		gtk.gdk.threads_enter()
		if procentage != "done":
			if procentage > 100: procentage = 100
			self.SyncProgressbar.set_fraction(float(procentage)/100)
		else:
			self.SyncProgressbar.set_fraction(1)
		gtk.gdk.threads_leave()

	def quit_application(self, widget, args = None):
		gtk.main_quit()

	def ToggleToolbar(self, toolbar):
		if toolbar.props.visible:
			toolbar.hide_all()
		else:
			toolbar.show_all()

	def ViewSelectedLabel(self, treeview = None, path = None, view_column = None):
		model, my_iter = self.labellistview.get_selection().get_selected()
		if model and my_iter:
			label = model.get_value(my_iter, 0)
			self.ViewLabel(label)

	def ViewLabel(self, label = None):
		"""View the mails in a label"""
		#Enable refreshing current label if needed
		if label == None:
			label = self.lastViewedLabel
		self.lastViewedLabel = label

		#Create list store
		self.mailliststore = gtk.ListStore(str, str, str, str, pango.Weight, gtk.gdk.Pixbuf, gtk.gdk.Pixbuf)
		self.maillistview.set_model(self.mailliststore)
		#Get mails and add them, remember to parse date
		for mail in self.gmail.list_label(label, ["sender","subject","date","msg_id", "read"]):

			conn, cur = self.gmail.get_database()
			cur.execute("SELECT signed, encrypted FROM mail_integrity WHERE msg_id = ? LIMIT 1", [mail[3]])
			result = cur.fetchone()
			if result:
				signed, encrypted = result
			else:
				signed, encrypted = False, False
			self.gmail.return_database(conn, cur)

			if signed:
				sig = self.MainWindow.render_icon(gtk.STOCK_APPLY, gtk.ICON_SIZE_MENU)
			else:
				sig = None
			if encrypted:
				enc = self.MainWindow.render_icon(gtk.STOCK_DIALOG_AUTHENTICATION, gtk.ICON_SIZE_MENU)
			else:
				enc = None

			#Get if it's new and should be bold
			if mail[4]:
				weight = pango.WEIGHT_NORMAL
			else:
				weight = pango.WEIGHT_BOLD
			self.mailliststore.append([mail[0], mail[1], datetime.datetime.fromtimestamp(mail[2]).ctime(), mail[3], weight, sig, enc])
		#Change view to index view:
		self.message_id = None
		self.conversation = None
		self.ContentViews.set_current_page(0)
		#Update labels menu and toolbar
		self.EmailSelectionChanged()

	def ViewSelectedMail(self, treeview, path, view_column):
		model, my_iter = treeview.get_selection().get_selected()
		msg_id = model.get_value(my_iter, 3)
		self.conversation = self.gmail.get_conversation(msg_id, "msg_id")
		self.message_id = msg_id
		if self.message_id not in self.conversation:
			raise ValueError, "Current message is not in the current conversation, gmail_cache fucked up!"
		self.ViewMail(msg_id)

	def PreviousMessageFromConversation(self, widget, args = None):
		"""Display previous message in conversation"""
		if self.conversation != None and self.message_id != None:
			if self.message_id not in self.conversation:
				raise ValueError, "Current message is not in the current conversation"
			elif self.conversation.index(self.message_id) >= len(self.conversation) -1:
				raise IndexError, "Conversation out of range"
			else:
				self.message_id = self.conversation[self.conversation.index(self.message_id)+1]
				self.ViewMail(self.message_id)
		else:
			raise ValueError, "conversation and message_id must be set!"

	def NextMessageFromConversation(self, widget, args = None):
		"""Display next message in conversation"""
		if self.conversation != None and self.message_id != None:
			if self.message_id not in self.conversation:
				raise ValueError, "Current message is not in the current conversation"
			elif self.conversation.index(self.message_id)-1 < 0:
				raise IndexError, "Conversation out of range"
			else:
				self.message_id = self.conversation[self.conversation.index(self.message_id)-1]
				self.ViewMail(self.message_id)
		else:
			raise ValueError, "conversation and message_id must be set!"

	def updateConversationButtons(self):
		"""Disable back button if we can go back, and disable forward button if we can't go forward in conversation"""
		if self.conversation != None and self.message_id != None:
			if self.message_id not in self.conversation:
				raise ValueError, "Current message is not in the current conversation"
			else:
				self.NextMailtoolbutton.set_sensitive(not self.conversation.index(self.message_id)-1 < 0)
				self.NextMenuItem.set_sensitive(not self.conversation.index(self.message_id)-1 < 0)
				self.PreviousMailtoolbutton.set_sensitive(not self.conversation.index(self.message_id) >= len(self.conversation) -1)
				self.BackMenuItem.set_sensitive(not self.conversation.index(self.message_id) >= len(self.conversation) -1)
		else:
			self.PreviousMailtoolbutton.set_sensitive(False)
			self.NextMailtoolbutton.set_sensitive(False)
			self.NextMenuItem.set_sensitive(False)
			self.BackMenuItem.set_sensitive(False)


	def ViewMailIndex(self, widget = None, Args = None):
		"""Event handler that moves to the Index mail"""
		self.ViewLabel()

	def ViewMail(self, msg_id):
		"""Displays a message and changes view to the current one"""
		[sender, recipient, subject, [message, mimetype], date, read] = self.gmail.get_message(msg_id, ["sender", "recipient", "subject" ,"message", "date", "read"])
		#Mark read if needed
		if not read:
			self.gmail.mark_read(msg_id, True)

		#Decrypt message
		message, decrypted, signed, pubkey = RSA.process_mail(message, self.PrivateKey)

		#Check that pubkey have been accepted for this sender
		if signed:
			self.gmail.database.execute("SELECT email FROM contacts WHERE e = ? AND n = ? LIMIT 1", [str(pubkey[0]), str(pubkey[1])])
			result = self.gmail.database.fetchone()
			if result and result[0] == sender:
				self.MailSignedIcon.show()
				self.MailUnsignedIcon.hide()
			else:
				self.MailSignedIcon.hide()
				self.MailUnsignedIcon.show()
		else:
			self.MailSignedIcon.hide()
			self.MailUnsignedIcon.show()

		#Set icons if it was decrypted
		if decrypted:
			self.MailEncryptedIcon.show()
		else:
			self.MailEncryptedIcon.hide()

		#Set subject
		subject = gobject.markup_escape_text(subject)
		self.SubjectLabel.set_text('<span size="xx-large">' + subject + '</span>')
		self.SubjectLabel.set_property("use-markup", True)
		#Set more information
		date = gobject.markup_escape_text(datetime.datetime.fromtimestamp(date).ctime())
		sender = gobject.markup_escape_text(sender)
		recipient = gobject.markup_escape_text(recipient)
		self.MoreInfoLabel.set_text("<b>From:</b> <i>" + sender +"</i>\n<b>To:</b> " + recipient + "\n<b>Date:</b> "+ date)
		self.MoreInfoLabel.set_property("use-markup", True)
		#Set mail content
		buf = self.Mailtextview.get_buffer()
		buf.set_text(message)

		tt = buf.get_tag_table()
		if tt.lookup("monospace") is None:
			buf.create_tag("monospace", font="courier 12")
		start, end = buf.get_bounds()
		buf.apply_tag_by_name("monospace", start, end)

		#Change view
		self.ContentViews.set_current_page(1)
		#Update labels menu and toolbar
		self.EmailSelectionChanged()

	def ToggleLabelList(self, widget = None, args = None):
		"""Shows hides the label list"""
		if self.LabelListScrolledwindow.props.visible:
			self.LabelListScrolledwindow.hide_all()
		else:
			self.LabelListScrolledwindow.show_all()

	def ToggleStatusBar(self, widget = None, args = None):
		"""Shows hides the status bar"""
		if self.StatusbarBox.props.visible:
			self.StatusbarBox.hide_all()
		else:
			self.StatusbarBox.show_all()

	def GetSelectedMessageID(self):
		"""Get msg_id of currently displayed or selected message, or return None"""
		msg_id = None
		if self.ContentViews.get_current_page() == 1 and self.message_id != None:
			msg_id = self.message_id
		elif self.ContentViews.get_current_page() == 0:
			model, my_iter = self.maillistview.get_selection().get_selected()
			if my_iter != None:
				msg_id = model.get_value(my_iter, 3)
		return msg_id

	def EmailSelectionChanged(self, widget = None, args = None):
		"""Updates toolbars, label menues and conversations buttons also in toolbar, if needed"""
		#Get msg_id of currently displayed or selected message
		msg_id = self.GetSelectedMessageID()

		#Alter label enablement
		if msg_id != None:
			self.AlteringLabelsMenu = True		#Ignore event while doing this
			labels = self.gmail.get_labels(msg_id)
			for label, MenuItem in self.TopLabelDic.iteritems():
				MenuItem.set_active(label in labels)
			for label, MenuItem in self.ToolLabelDic.iteritems():
				MenuItem.set_active(label in labels)
			self.AlteringLabelsMenu = False		#Show ignoring events
			#Enable archive button if message is in INBOX
			self.ArchiveToolButton.set_sensitive("INBOX" in labels)
			self.ArchiveMenuItem.set_sensitive("INBOX" in labels)
		else:
			self.ArchiveToolButton.set_sensitive(False)
			self.ArchiveMenuItem.set_sensitive(False)

		#Enable/disable menu entries and toolbar buttons
		self.TopLabelMainMenu.set_sensitive(msg_id != None)
		self.LabelToolButton.set_sensitive(msg_id != None)
		self.ReplyToolButton.set_sensitive(msg_id != None)
		self.Deletetoolbutton.set_sensitive(msg_id != None)
		self.DeleteMenuItem.set_sensitive(msg_id != None)
		self.ReplyMenuItem.set_sensitive(msg_id != None)

		#Update state of conversations buttons
		self.updateConversationButtons()

	def CreateLabelMenu(self):
		"""Creates a label menu and disables it"""
		#Create menu and submenu for top menu and toolbar
		self.ToolLabelMenu = gtk.Menu()
		self.LabelToolButton.set_menu(self.ToolLabelMenu)
		self.TopLabelMenu = gtk.Menu()
		self.TopLabelMainMenu.set_submenu(self.TopLabelMenu)

		self.TopLabelDic = {}
		self.ToolLabelDic = {}

		#Add a menu item foreach label
		for label in self.gmail.get_labels():
			if "[Gmail]" in label and label != "[Gmail]/Starred":
				continue
			self.TopLabelDic[label] = gtk.CheckMenuItem(label, False)
			self.TopLabelMenu.append(self.TopLabelDic[label])
			self.TopLabelDic[label].connect("toggled", self.ToggleLabel, label)
			self.ToolLabelDic[label] = gtk.CheckMenuItem(label, False)
			self.ToolLabelMenu.append(self.ToolLabelDic[label])
			self.ToolLabelDic[label].connect("toggled", self.ToggleLabel, label)

		#Append new label menu entry
		self.TopApplyNewLabelMenuItem = gtk.MenuItem("Apply _new label")
		self.TopLabelMenu.append(self.TopApplyNewLabelMenuItem)
		self.TopApplyNewLabelMenuItem.connect("activate", self.ApplyNewLabel)
		self.ToolApplyNewLabelMenuItem = gtk.MenuItem("Apply _new label")
		self.ToolLabelMenu.append(self.ToolApplyNewLabelMenuItem)
		self.ToolApplyNewLabelMenuItem.connect("activate", self.ApplyNewLabel)

		#Lock so that we can ignore events that occur while we do set_active on menu items later on
		self.AlteringLabelsMenu = False

		#Run showall
		self.TopLabelMenu.show_all()
		self.ToolLabelMenu.show_all()
		#Disable them from start
		self.TopLabelMainMenu.set_sensitive(False)
		self.LabelToolButton.set_sensitive(False)

	def ToggleLabel(self, checkMenuItem, label = None):
		"""Remove/add labels"""
		if self.AlteringLabelsMenu:	#Ignore if we're editing labels
			return None

		#Get msg_id of message
		msg_id = self.GetSelectedMessageID()

		#Change label settings
		if msg_id != None:
			if checkMenuItem.get_active():
				self.gmail.add_label(msg_id, label)
			else:
				self.gmail.remove_label(msg_id, label)
			if self.ContentViews.get_current_page() == 0:
				self.ViewLabel()
			else:
				self.EmailSelectionChanged()
				
		else:
			#Change label setting
			self.AlteringLabelsMenu = True
			checkMenuItem.Toggle()
			self.AlteringLabelsMenu = False

	def ApplyNewLabel(self, widget = None, Args = None):
		#Get msg_id of message
		msg_id = self.GetSelectedMessageID()

		#Change label settings
		if msg_id != None:
			labels = self.gmail.get_labels()
			msgbox = applyLabelDialog.ApplyLabelDialog(labels)
			result, labelname = msgbox.run()
			if result == 1:
				try:
					self.gmail.add_label(msg_id, labelname)
					#Update labels:
					self.CreateLabelMenu()
					self.update_labels()
				except:
					pass	#I assume label was probably already applied :)
				if self.ContentViews.get_current_page() == 0:
					self.ViewLabel()
				else:
					self.EmailSelectionChanged()

	def ArchiveSelectedMail(self, widget = None, args = None):
		"""Removes a message from inbox"""
		#Get msg_id of message
		msg_id = self.GetSelectedMessageID()
		if msg_id != None:
			self.gmail.remove_label(msg_id, "INBOX")
			self.ViewLabel()

	def DeleteSelectedMessage(self, widget = None, args = None):
		"""Delete selected message, ask for confirmation first"""
		msg_id = self.GetSelectedMessageID()
		if msg_id != None:
			[[subject, sender]] = self.gmail.get_message(msg_id, ["subject", "sender"])
			msgbox = deleteMessageDialog.DeleteMessageDialog(subject, sender)
			if msgbox.run() == 1:
				self.gmail.delete_message(msg_id)
				self.ViewLabel()
	
	def WriteNewEmail(self, widget = None, Args = None):
		"""Write new email"""
		self.message_id = None
		self.conversation = None
		#Change view
		self.ContentViews.set_current_page(2)
		#Clear the message
		self.ClearNewEmail()
		#Update labels menu
		self.EmailSelectionChanged()
		self.EncryptCheckbutton.set_active(False)

	def WriteReplyEmail(self, widget = None, Args = None):
		"""Write new email as reply"""
		#Clear the email space
		self.ClearNewEmail()

		#Get something to reply to
		self.in_reply_to_id = self.GetSelectedMessageID()

		#Set To address and subject if possible
		if self.in_reply_to_id != None:
			[[sender, subject]] = self.gmail.get_message(self.in_reply_to_id, ["sender", "subject"])
			self.ToEntry.set_text(sender)
			if not subject.startswith("Re: "):
				subject = "Re: " + subject
			self.SubjectEntry.set_text(subject)
		self.message_id = None
		self.conversation = None
		#Change view
		self.ContentViews.set_current_page(2)
		#Update labels menu and toolbar
		self.EmailSelectionChanged()

		#Default to false
		self.EncryptCheckbutton.set_active(False)

	def ClearNewEmail(self, widget = None, Args = None):
		"""Clear current email"""
		self.ToEntry.set_text("")
		self.SubjectEntry.set_text("")
		self.NewMailContentTextview.get_buffer().set_text("")
		self.in_reply_to_id = None
		self.SignCheckbutton.set_active(True)
		self.SendNewMailButton.set_sensitive(False)

	ignore_to_entry_change = False	#Used when to_entry is modified on another thread
	def on_ToEntry_changed(self, widget = None, Args = None):
		"""Update enablement of send new mail button"""
		if self.ignore_to_entry_change:
			return None

		to = self.ToEntry.get_text()
		self.SendNewMailButton.set_sensitive("@" in to)

		#Check if we have the key of the recipient
		self.gmail.database.execute("SELECT e, n FROM contacts WHERE email = ? LIMIT 1", [unicode(to)])
		result = self.gmail.database.fetchone()
		if result and result[0] != '0' and result[1] != '0':
			self.EncryptCheckbutton.set_sensitive(True)
		else:
			self.EncryptCheckbutton.set_sensitive(False)
			self.EncryptCheckbutton.set_active(False)

	@thread
	def SendNewEmail(self, widget = None, Args = None):
		gtk.gdk.threads_enter()	#Enter GUI thread
		#Create a message
		mail = email.message.Message()
		to = self.ToEntry.get_text()
		mail["To"] = to
		mail["From"] = self.gmail.username
		mail["Subject"] = self.SubjectEntry.get_text()
		buf = self.NewMailContentTextview.get_buffer()
		payload = buf.get_text(buf.get_start_iter(), buf.get_end_iter())
		#To support attachments see: http://snippets.dzone.com/posts/show/2038

		#If this is a reply, let it be noted
		if self.in_reply_to_id:
			mail["In-Reply-To"] = self.in_reply_to_id
			msg_ids = self.gmail.get_conversation(self.in_reply_to_id, "msg_id")
			if isinstance(msg_ids, (list, tuple)):
				msg_ids = "\r\n\t ".join(msg_ids)
			mail["References"] = msg_ids

		#Write status message and disable GUI
		self.WriteEmailvBox.set_sensitive(False)
		self.statusbar.pop(self.send_email_id)
		self.statusbar.push(self.send_email_id, "Sending email. This may take a while...")

		#Get if we should encrypt and/or sign
		encrypt = self.EncryptCheckbutton.get_active()
		sign = self.SignCheckbutton.get_active()
		gtk.gdk.threads_leave()	#Leave GUI thread


		tokey = None	#Get to key if it's possible
		if encrypt:
			#Get database connection and cursor for this thread
			conn, cur = self.gmail.get_database()
			cur.execute("SELECT e,n FROM contacts WHERE email = ? LIMIT 1", [to])
			tokey = cur.fetchone()
			if tokey:
				tokey = [int(tokey[0]), int(tokey[1])]
			self.gmail.return_database(conn, cur)

		#Replace single linebreak by \r\n as used in emails, otherwise server or email libraries does this which f*cksup the signature
		payload = payload.replace("\n", "\r\n")

		#Sign if needed
		if sign:
			payload = RSA.prepare_mail(payload, self.PrivateKey, self.PublicKey, tokey)	#This will also encrypt if tokey is not None
		elif encrypt:	#Encrypt if that all we have to do
			payload = RSA.prepare_mail(payload, None, None, tokey)
		
		#Set payload
		mail.set_payload(payload)

		#Send the message
		Failed = False
		try:
			self.gmail.send_message(mail)
		except:
			Failed = True

		#Clear email
		gtk.gdk.threads_enter()
		self.statusbar.pop(self.send_email_id)
		if Failed:
			self.statusbar.push(self.send_email_id, "Failed to transmit email!")
		else:
			self.statusbar.push(self.send_email_id, "Email sent")
			self.ignore_to_entry_change = True	#This will modify to_entry and it's done on another thread, db will be mad if we use it from there
			self.ClearNewEmail()
			self.ignore_to_entry_change = False
		self.WriteEmailvBox.set_sensitive(True)
		gtk.gdk.threads_leave()

	def PopulateContacts(self):
		"""Create completion"""
		self.ContactCompletion = gtk.EntryCompletion()
		self.ToEntry.set_completion(self.ContactCompletion)

		self.ContactStore = gtk.ListStore(str)
		self.ContactCompletion.set_model(self.ContactStore)
		self.ContactCompletion.set_text_column(0)
		self.ContactCompletion.set_match_func(self.match_func)

		self.gmail.database.execute("SELECT email FROM contacts")
		for contact in self.gmail.database.fetchall():
			self.ContactStore.append(contact)

	def ProcessNewMail(self, msg_id, cursor):
		"""Extracts from and to email addresses and add them to the contacts tables, if they're not there
			Ask for trust to public keys and marks mails as encrypted and signed if so...
		"""
		cursor.execute("SELECT message FROM mails WHERE msg_id = ?", [msg_id])
		mail = pickle.loads(cursor.fetchone()[0])

		#Attempt decrypt and get public key
		message, decrypted, integrity, [pub_e, pub_n] = RSA.process_mail(self.gmail._extract_content(mail)[0], self.PrivateKey)

		#determine if key is provided
		key_provided = pub_e != 0 and pub_n != 0

		if mail["from"]:
			cursor.execute("SELECT e,n FROM contacts WHERE email = ?", [mail["from"]])
			result = cursor.fetchone()
			if result and key_provided:
				e, n = [int(result[0]),int(result[1])]
				#If it doesn't match ask the user
				if e != pub_e or n != pub_n:
					vdialog = verifyPublickeyDialog.VerifyPublickeyDialog(mail["from"], [pub_e, pub_n], [e, n])
					if vdialog.run() > 0:	#Update public key
						cursor.execute("UPDATE contacts SET e = ?, n = ? WHERE email = ?", [str(pub_e), str(pub_n), mail["from"]])
			elif key_provided and not result:
				#If key provided but no contact is in database ask if we should add key
				vdialog = verifyPublickeyDialog.VerifyPublickeyDialog(mail["from"], [pub_e, pub_n], [0, 0])
				if vdialog.run() > 0:	#Update public key
					cursor.execute("INSERT INTO contacts (email, e, n) VALUES (?, ?, ?)", [mail["from"], str(pub_e), str(pub_n)])
					self.ContactStore.append([mail["from"]])
				else:	#Add contact
					cursor.execute("INSERT INTO contacts (email, e, n) VALUES (?, ?, ?)", [mail["from"], '0', '0'])
					self.ContactStore.append([mail["from"]])
			elif not result:	#Add contact
				cursor.execute("INSERT INTO contacts (email, e, n) VALUES (?, ?, ?)", [mail["from"], '0', '0'])
				self.ContactStore.append([mail["from"]])

		#Add to contacts
		if mail["to"]:
			#Add as contacts if not in database, and associated key 0,0
			for contact in mail["to"].split(","):
				cursor.execute("SELECT COUNT(email) FROM contacts WHERE email = ?", [contact])
				if cursor.fetchone()[0] == 0:
					cursor.execute("INSERT INTO contacts (email, e, n) VALUES(?,?,?)", [contact, '0', '0'])
					self.ContactStore.append([contact])

		#Add mail to mail_integrity table
		cursor.execute("INSERT INTO mail_integrity (msg_id, signed, encrypted) VALUES (?, ?, ?)", [msg_id, integrity, decrypted])
	
	def match_func(self, completion, key, it):
		model = completion.get_model()
		text = model.get_value(it, 0)
		if key == None or text == None:
			return False
		return key in text

if __name__ == "__main__":
	#Initilize thread
	gtk.gdk.threads_init()
	g = gmail_cache.G(False)
	pub = (49829598829388024842324315337463371929L, 125169029050632931069782617839713613579L)
	priv = (38244159455870338598276748375600108649L, 125169029050632931069782617839713613579L)
	MainWindow(g, pub, priv)
	gtk.main()
