#!/usr/bin/env python
# -*- coding: utf-8 -*-

try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
	import gobject
	import gtk.gdk
	import pango
except:
	sys.exit(1)

import gladeWindow
from gladeWindow import thread
import RSA
import gmail_cache
import mainWindow

#We're using YAML for parsing the configfile
import yaml

class StartAssistant(gladeWindow.GladeWindow):
	PublicKey = None
	PrivateKey = None
	Gmail = None
	kill = False

	def __init__(self, default_db_path = "."):
		gladeWindow.GladeWindow.__init__(self, "raptormail.glade", "StartAssistant")
		self.complete_current_page()
		self.db_path = default_db_path + "/RaptorMail.db"

	def on_StartAssistant_apply(self, assistant):
		"""Start the mainWindow and kill this one"""

		#Close this guide
		self.kill = True

	def run(self):
		"""Run this guide as a dialog"""
		self.kill = False

		#While not ready to die
		while(not self.kill):
			gtk.main_iteration()

		#prepare return value
		R = self.Gmail, self.PublicKey, self.PrivateKey, self.db_path

		#Destroy the assistant
		self.StartAssistant.destroy()

		return R

	def on_StartAssistant_cancel(self, assistant):
		self.Gmail = None
		self.kill = True

	def on_StartAssistant_prepare(self, assistant, page):
		"""Prepare page for being viewed"""
		page_index = self.StartAssistant.get_current_page()
		if page_index == 1:
			self.KeyGenProgressbar.set_pulse_step(0.05)
			self.KeyGenProgressbar.pulse()
			gobject.timeout_add(100, self.show_keygen_progress)
			self.KeyGenStatelabel.set_text("Generating keyset...")
			self.generate_key()
		elif page_index == 2:
			pass	#Do nothing
		else:
			self.complete_current_page()

	def show_keygen_progress(self):
		"""Updates progress during keygeneration"""
		self.KeyGenProgressbar.pulse()
		return self.PrivateKey == None

	@thread
	def generate_key(self):
		"""Generate keyset on worker thread"""
		self.PublicKey, self.PrivateKey = RSA.generatekey(512)
		gtk.gdk.threads_enter()
		self.complete_current_page()
		self.KeyGenStatelabel.set_text("Generation complete.")
		gtk.gdk.threads_leave()

	def complete_current_page(self):
		"""Completes the current page in the Assistant so that user can move on"""
		cpagenr = self.StartAssistant.get_current_page()
		page = self.StartAssistant.get_nth_page(cpagenr)
		self.StartAssistant.set_page_complete(page, True)

	#Events:

	def on_SyncButton_clicked(self, button):
		"""Create gmail instance and ask try to sync it"""
		username = self.UsernameEntry.get_text()
		password = self.PasswordEntry.get_text()
		self.SyncButton.set_sensitive(False)
		self.Gmail = gmail_cache.GMail(username, password, self.db_path)
		self.start_gmail_sync()

	@thread
	def start_gmail_sync(self):
		"""Attempt login at GMail and start synching"""
		if not self.Gmail._login():
			self.Gmail = None
			gtk.gdk.threads_enter()
			self.SyncButton.set_sensitive(True)
			gtk.gdk.threads_leave()
			pass #TODO: Fix bad pwd
		else:
			self.Gmail.progress_report = self.update_sync_progress
			self.Gmail.sync()

	#thread
	def update_sync_progress(self, procentage):
		"""Update sync progress from GMail"""
		gtk.gdk.threads_enter()
		if procentage >= 100:
			self.SyncProgressbar.set_fraction(1)
			self.complete_current_page()
		else:
			self.SyncProgressbar.set_fraction(float(procentage)/100)
		
		gtk.gdk.threads_leave()

if __name__ == "__main__":
	#if loadable start application
	#if not loadable start first time guide:
	#TODO: load language
	#pango.Context.set_language(pango.pango_language_from_string("EN"))
	#Initilize thread
	gtk.gdk.threads_init()
	StartAssistant("./RaptorMail.conf")
	gtk.main()
