#!/usr/bin/env python
# -*- coding: utf-8 -*-

try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
	import gobject
	import gtk.gdk
except:
	sys.exit(1)

import sha
import gladeWindow

class VerifyPublickeyDialog(gladeWindow.GladeWindow):

	def __init__(self, sender, pubkey, old_pubkey = [0,0]):
		""" Creates a dialog that asks the user to verify that sender has public key and
			 warns that an old public key is associated with the contact
			sender: String representation of who send the mail
			pubkey: tuple of e, n of public key to be verified
			old_pubkey: tuple of e, n of old public key to be dismissed, 0,0 if none
		"""
		#Initialize GUI
		gladeWindow.GladeWindow.__init__(self, "raptormail.glade", "VerifyPublickeyDialog")
		text = "<b>An unknown public key has arrived</b>\n"
		text += gobject.markup_escape_text(sender) + "\n"
		text += "has sent you a message with an unrecognised public key.\n"
		text += "The key is:\n"
		text += gobject.markup_escape_text(sha.new(hex(pubkey[0])).hexdigest()) + "\n"
		text += gobject.markup_escape_text(sha.new(hex(pubkey[1])).hexdigest()) + "\n"
		text += "Do you trust this key to be valid?\n\n"
		if old_pubkey != [0,0]:
			text += "You have previously verified another key from this person:\n"
			text += gobject.markup_escape_text(sha.new(hex(old_pubkey[0])).hexdigest()) + "\n"
			text += gobject.markup_escape_text(sha.new(hex(old_pubkey[1])).hexdigest()) + "\n"
			text += "If you trust the new key, the old key will be deleted.\n"
			text += "If you have any reason to believe somebody is trying steal\n"
			text += "the identity of:\n"
			text += gobject.markup_escape_text(sender) + "\n"
			text += "<b>Then do NOT trust the new key</b>"
		self.PublicKeyLabel.set_text(text)
		self.PublicKeyLabel.set_use_markup(True)


	def run(self):
		"""Runs the dialog and return something above 0 if public is accepted"""
		self.result = self.VerifyPublickeyDialog.run()
		self.VerifyPublickeyDialog.destroy()
		return self.result

